// dynma.cpp  Klasse matrix dynamisch

#include <iostream>

using namespace std;

const int DIM = 3;
class matrix {
      private:
         int zeilen, spalten;
         void init();
         double **elem;
      public:
         matrix();
         matrix(int dim);
         matrix(int zeilen, int spalten);
         double &operator() (int i, int j) {
           return(elem[i - 1][j - 1]);
         }
         void input();
         void print();
         ~matrix();
};

void matrix::init() {  // Ausnullen
     int i, j;
     for(i = 0; i < zeilen; i++) {
       for(j = 0; j < spalten; j++) {
             elem[i][j] = 0.0;
       }
     }
}

matrix::matrix() : zeilen(DIM), spalten(DIM) { // Standard-Konstruktor
     int i;
     elem = new double *[DIM];
     for(i = 0; i < DIM; i++) {
           elem[i] = new double[DIM];
     }
     init();
}

matrix::matrix(int dim) : zeilen(dim), spalten(dim) { // m x m - Konstruktor
     int i;
     elem = new double *[dim];
     for(i = 0; i < dim; i++) {
           elem[i] = new double[dim];
     }
     init();
}

matrix::matrix(int z, int s):  zeilen(z), spalten(s) { // n x m - Konstruktor
     int i;
     elem = new double *[zeilen];
     for(i = 0; i < zeilen; i++) {
           elem[i] = new double[spalten];
     }
     init();
}

void matrix::print() {
     int i, j;
     for(i = 0; i < zeilen; i++) {
       for(j = 0; j < spalten; j++) {
           cout << elem[i][j] << '\t';
       }
       cout << endl;
     }
}

void matrix::input() {
     int i, j;
     for(i = 0; i < zeilen; i++) {
           cout << "Matrix (" << i+1 << ". Zeile)[1.." << spalten << "]: ";
       for(j = 0; j < spalten; j++) {
           cin >> elem[i][j];
       }
     }
}

matrix::~matrix() {
}

int main(){
    int zeilen, spalten;

    cout << "Bitte Matrix-Dimension eingeben (Zeilen, Spalten): ";
    cin >> zeilen >> spalten;
    matrix a(zeilen, spalten);
    a.print();
    cout << endl;
    cout << "Bitte die Matrix eingeben:" << endl;
    a.input();
    cout << endl;
    a.print();
    cout << endl;
    cout << "Das Element [3][3] bei einer 3 x 3 - Matrix: " << a(3, 3) << endl;
    cout << endl << "Welches Element soll ausgegeben werden? ";
    cin >> zeilen >> spalten;
    cout << a(zeilen, spalten);

    cout << endl;
    return 0;
}
